Bug 195986 - Expected shouldn't assume its contained types are copyable
Summary: Expected shouldn't assume its contained types are copyable
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: New Bugs (show other bugs)
Version: WebKit Nightly Build
Hardware: Unspecified Unspecified
: P2 Normal
Assignee: Alex Christensen
URL:
Keywords: InRadar
Depends on:
Blocks:
 
Reported: 2019-03-19 21:41 PDT by Alex Christensen
Modified: 2019-03-25 22:55 PDT (History)
11 users (show)

See Also:


Attachments
Patch (8.26 KB, patch)
2019-03-19 21:45 PDT, Alex Christensen
no flags Details | Formatted Diff | Diff
Patch (8.31 KB, patch)
2019-03-19 22:59 PDT, Alex Christensen
no flags Details | Formatted Diff | Diff
Archive of layout-test-results from ews107 for mac-highsierra-wk2 (2.91 MB, application/zip)
2019-03-20 00:41 PDT, EWS Watchlist
no flags Details
Patch (10.53 KB, patch)
2019-03-25 14:29 PDT, Alex Christensen
no flags Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Alex Christensen 2019-03-19 21:41:49 PDT
Expected needn't assume its contained types are copyable
Comment 1 Alex Christensen 2019-03-19 21:45:36 PDT
Created attachment 365305 [details]
Patch
Comment 2 EWS Watchlist 2019-03-19 21:48:06 PDT
Attachment 365305 [details] did not pass style-queue:


ERROR: Source/WTF/wtf/Expected.h:252:  constexpr_storage is incorrectly named. Don't use underscores in your identifier names.  [readability/naming/underscores] [4]
ERROR: Source/WTF/wtf/Expected.h:253:  constexpr_storage is incorrectly named. Don't use underscores in your identifier names.  [readability/naming/underscores] [4]
ERROR: Source/WTF/wtf/Expected.h:314:  constexpr_base is incorrectly named. Don't use underscores in your identifier names.  [readability/naming/underscores] [4]
ERROR: Source/WTF/wtf/Expected.h:315:  constexpr_base is incorrectly named. Don't use underscores in your identifier names.  [readability/naming/underscores] [4]
Total errors found: 4 in 5 files


If any of these errors are false positives, please file a bug against check-webkit-style.
Comment 3 Alex Christensen 2019-03-19 21:48:19 PDT
Comment on attachment 365305 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=365305&action=review

> Source/WTF/wtf/Unexpected.h:53
> +        template <class U = E>
> +          constexpr explicit unexpected(E&&);

Note, it looks like this has been addressed in subsequent revisions of http://wg21.link/p0323
Comment 4 Alex Christensen 2019-03-19 22:59:03 PDT
Created attachment 365318 [details]
Patch
Comment 5 EWS Watchlist 2019-03-19 23:02:06 PDT
Attachment 365318 [details] did not pass style-queue:


ERROR: Source/WTF/wtf/Expected.h:253:  constexpr_storage is incorrectly named. Don't use underscores in your identifier names.  [readability/naming/underscores] [4]
ERROR: Source/WTF/wtf/Expected.h:255:  constexpr_storage is incorrectly named. Don't use underscores in your identifier names.  [readability/naming/underscores] [4]
ERROR: Source/WTF/wtf/Expected.h:317:  constexpr_base is incorrectly named. Don't use underscores in your identifier names.  [readability/naming/underscores] [4]
ERROR: Source/WTF/wtf/Expected.h:319:  constexpr_base is incorrectly named. Don't use underscores in your identifier names.  [readability/naming/underscores] [4]
Total errors found: 4 in 5 files


If any of these errors are false positives, please file a bug against check-webkit-style.
Comment 6 EWS Watchlist 2019-03-20 00:41:18 PDT
Comment on attachment 365318 [details]
Patch

Attachment 365318 [details] did not pass mac-wk2-ews (mac-wk2):
Output: https://webkit-queues.webkit.org/results/11576676

New failing tests:
http/wpt/mediarecorder/MediaRecorder-AV-audio-video-dataavailable.html
Comment 7 EWS Watchlist 2019-03-20 00:41:19 PDT
Created attachment 365325 [details]
Archive of layout-test-results from ews107 for mac-highsierra-wk2

The attached test failures were seen while running run-webkit-tests on the mac-wk2-ews.
Bot: ews107  Port: mac-highsierra-wk2  Platform: Mac OS X 10.13.6
Comment 8 JF Bastien 2019-03-20 09:20:44 PDT
Comment on attachment 365318 [details]
Patch

lgtm!
Comment 9 Alex Christensen 2019-03-20 11:50:16 PDT
Could someone get this building on Linux?
Comment 10 Michael Catanzaro 2019-03-20 15:43:08 PDT
(In reply to Alex Christensen from comment #9)
> Could someone get this building on Linux?

Probably tonight
Comment 11 Michael Catanzaro 2019-03-20 17:25:21 PDT
Bad news is that it builds perfectly fine for me. The GTK and WPE EWS are both on  still on GCC 6 to ensure compatibility with Debian Stretch.

It looks like the only build errors are on lines 259, 261, 263, and 277 of ContentExtensionParser.cpp, returning a Expected<Optional<Action>, std::error_code>. Maybe you could try making the conversions there more explicit? 

return Expected { Optional { ActionType::BlockLoad }, std::error_code() };

If that doesn't please the EWS and you're really having trouble, I can install Stretch in a VM and fight it there.
Comment 12 Alex Christensen 2019-03-25 14:29:43 PDT
Created attachment 365901 [details]
Patch
Comment 13 EWS Watchlist 2019-03-25 14:31:41 PDT
Attachment 365901 [details] did not pass style-queue:


ERROR: Source/WTF/wtf/Expected.h:253:  constexpr_storage is incorrectly named. Don't use underscores in your identifier names.  [readability/naming/underscores] [4]
ERROR: Source/WTF/wtf/Expected.h:255:  constexpr_storage is incorrectly named. Don't use underscores in your identifier names.  [readability/naming/underscores] [4]
ERROR: Source/WTF/wtf/Expected.h:317:  constexpr_base is incorrectly named. Don't use underscores in your identifier names.  [readability/naming/underscores] [4]
ERROR: Source/WTF/wtf/Expected.h:319:  constexpr_base is incorrectly named. Don't use underscores in your identifier names.  [readability/naming/underscores] [4]
Total errors found: 4 in 7 files


If any of these errors are false positives, please file a bug against check-webkit-style.
Comment 14 WebKit Commit Bot 2019-03-25 22:54:02 PDT
Comment on attachment 365901 [details]
Patch

Clearing flags on attachment: 365901

Committed r243486: <https://trac.webkit.org/changeset/243486>
Comment 15 WebKit Commit Bot 2019-03-25 22:54:04 PDT
All reviewed patches have been landed.  Closing bug.
Comment 16 Radar WebKit Bug Importer 2019-03-25 22:55:17 PDT
<rdar://problem/49248813>